--[[
    Run this script on just one toon once all of your toons are loaded:
        /lua run clear-eq-window-notifications.lua
    
    I made this to automatically clear the Windows notifications
    as I run a raid force and grew tired of clicking through
    every single toon just to remove the highlight of my EQ icon.
    
    Depending on your system, you may want to adjust the delay_value
    based on your system performance.

    Requirement: MQ2Dannet
    Version: 1.0 (3/9/2024)
    -hytiek
]]
local mq = require('mq')
-- your mileage may vary, adjust as desired
--@param string
local delay_value = "2s"
-- do not modify these
local count = 0
local cResult = nil
-- helper function to create table
local function split(s, delimiter)
    local result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end
-- pulls Windows focus to toon, presents a count for expectation
-- and cleans up any eq windows which might be open
local function clear_notification(who, current_value, total_count)
    if who == string.lower(mq.TLO.Me.CleanName()) then
        mq.cmd("/multiline ; /foreground; /timed 5 /cleanup; /timed 10 /cleanup; /timed 20 /cleanup")
        mq.cmdf("/popcustom 14 5 Clearing notification [ %s / %s ]", current_value, total_count)
    else
        mq.cmdf("/dex %s /multiline ; /foreground; /timed 5 /cleanup; /timed 10 /cleanup; /timed 20 /cleanup", who)
        mq.cmdf("/dex %s /popcustom 14 5 Clearing notification [ %s / %s ]", who, current_value, total_count)
    end
    mq.delay(delay_value)
end
-- check if dannet is loaded, exit if not
if mq.TLO.Plugin("mq2dannet").IsLoaded() == true then
    local arg1 = mq.TLO.DanNet.Peers() 
    local frontDelim = mq.TLO.DanNet.FrontDelim()
    if string.find(arg1, "|") then
        for i in arg1:gmatch("|") do
            count = count + 1
          end
         cResult = split(arg1,'|')
    end
    if frontDelim ~= true then
        for i=1, count do
            if cResult ~= nil then
                clear_notification(cResult[tonumber(i)], i, count)
            end
        end
    else
        for i=2, count+1 do
            if cResult ~= nil then
                clear_notification(cResult[tonumber(i)], i, count)
            end
        end
    end
else
    print("ERROR: This is to be used with MQ2Dannet and you don't have it loaded.")
    mq.exit()
end
-- return focus to where it was started
mq.cmd("/foreground")
-- intentional end of file